<template>
  <div class="q-pa-md row">
    <div class="col col-md-3 col-sm-12 col-xs-12 q-pa-md">
      <TodoForm
        :activeId="activeId"
        v-model="activeId"
        @getTodoList="getTodoList()"
      />
    </div>

    <div class="col col-md-9 col-sm-12 col-xs-12">
      <q-table
        :grid="$q.screen.sm"
        :flat="!$q.screen.sm"
        bordered
        :rows="copy_rows"
        :columns="columns"
        row-key="title"
        separator="none"
        :rows-per-page-options="[0]"
      >
        <template v-slot:top-right>
          <q-input
            class="q-my-md"
            color="secondary"
            v-model="search"
            label="Search"
          >
            <template v-slot:prepend>
              <q-icon name="search" />
            </template>
          </q-input>
        </template>

        <template v-slot:top-left>
          <q-btn
            color="secondary"
            label="refresh(show all)"
            @click="getTodoList"
            :loading="loading"
            :disable="loading"
          />
        </template>

        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td key="id" :props="props">
              <q-icon
                name="visibility_off"
                class="pointer"
                size="2em"
                @click="hide(props.row.id)"
              />
            </q-td>
            <q-td key="title" :props="props">
              {{ props.row.title }}
            </q-td>
            <q-td key="description" :props="props">
              {{ props.row.description }}
            </q-td>
            <q-td key="created" :props="props">
              {{ props.row.created }}
            </q-td>
            <q-td key="action" :props="props">
              <q-icon
                name="info"
                class="pointer"
                size="2em"
                @click="showTasks(props.row.id)"
              />
              <q-icon
                name="edit"
                class="pointer"
                size="2em"
                @click="showUpdateTodoInfo(props.row.id)"
              />
              <q-icon
                name="delete"
                class="pointer"
                size="2em"
                @click="deleteTodo(props.row.id)"
              />
            </q-td>
          </q-tr>
        </template>
      </q-table>
    </div>
  </div>
</template>

<script setup>
import axios from "axios";
import { computed, reactive, ref, watch, onMounted } from "vue";
import { useRouter } from "vue-router";
import TodoForm from "../components/Todo/TodoForm.vue";

const columns = [
  {
    name: "id",
    align: "left",
    label: "",
    field: "id",
    sortable: false,
  },
  {
    name: "title",
    required: true,
    label: "Title",
    align: "left",
    field: (row) => row.title,
    format: (val) => `${val}`,
    sortable: true,
  },
  {
    name: "description",
    align: "left",
    label: "Description",
    field: "description",
    sortable: true,
  },
  {
    name: "created",
    label: "Creation Date",
    field: "created",
    sortable: true,
  },

  { name: "action", label: "", field: "action", sortable: false },
];

function hide(id) {
  let index = rows.findIndex((x) => x.id == id);
  rows.splice(index, 1);
}

const router = useRouter();
let loading = ref(false);
let test = ref();
let rows = reactive([]);
let activeId = ref();

// -----------------lifecycle
onMounted(() => {
  getTodoList();
});
// -----------------lifecycle
// -----------------crud
async function getTodoList() {
  loading.value = true;
  rows.splice(0, rows.length); //It's a bad way, but I don't know what the right way is
  // rows = [];
  // copy_rows.value = []; 
  await axios
    .get(`https://todolist-965e6-default-rtdb.firebaseio.com/todo.json`)
    .then((response) => {
      if (response.data) {
        let all_data = Object.entries(response.data);
        for (let i = 0; i < all_data.length; i++) {
          const element = all_data[i];
          const date = new Date(element[1].created);

          rows.push({
            id: element[0],
            title: element[1].title,
            description: element[1].description,
            created: `${date.getFullYear()}/${date.getDate()}/${date.getMonth()}`,
          });
        }
      }

      loading.value = false;
    });
}

async function deleteTodo(id) {
  await axios
    .delete(
      `https://todolist-965e6-default-rtdb.firebaseio.com/todo/${id}.json`
    )
    .then((response) => {
      getTodoList();
    });
}
// -----------------crud

let search = ref("");
let copy_rows = computed(() => {
  if (search.value == "") {
    return rows;
  } else {
    let filtered = [];
    filtered = rows.filter(
      (x) =>
        x.title.toLowerCase().includes(search.value) ||
        x.description.toLowerCase().includes(search.value)
    );

    return filtered;
  }
});

function showTasks(id) {
  router.push("/" + id);
}

function showUpdateTodoInfo(id) {
  activeId.value = id;
}
</script>
